#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXN 128

static _Bool graph[MAXN][MAXN];
static size_t n;
static unsigned result;

static void
vertex (size_t v)
{
  size_t queue[MAXN], queue_len, i;

  queue_len = 0;
  for (i = 0; i < MAXN; i++)
    {
      if (i != v && graph[v][i] != 0)
	queue[queue_len++] = i;
    }
  if (queue_len == 0)
    {
      result++;
      return;
    }
  while (queue_len != 0 && result <= 1000)
    {
      size_t q2[MAXN], q2_len;

      q2_len = 0;
      for (i = 0; i < queue_len; i++)
	{
	  size_t j;

	  for (j = i + 1; j < queue_len; j++)
	    {
	      if (graph[queue[i]][queue[j]] == 0)
		{
		  q2[q2_len++] = queue[j];
		  queue[j] = queue[queue_len];
		}
	    }
	}
      result++;
      for (i = 0; i < queue_len; i++)
	{
	  graph[v][queue[i]] = 0;
	  graph[queue[i]][v] = 0;
	}
      for (i = 0; i < queue_len; i++)
	{
	  size_t j;

	  for (j = i + 1; j < queue_len; j++)
	    {
	      graph[queue[i]][queue[j]] = 0;
	      graph[queue[j]][queue[i]] = 0;
	    }
	}
      memcpy (queue, q2, q2_len * sizeof (*q2));
      queue_len = q2_len;
    }
}

int
main (void)
{
  unsigned m;

  while (scanf ("%zu%u", &n, &m) == 2)
    {
      size_t i;

      memset (graph, 0, n * sizeof (*graph));
      while (m != 0)
	{
	  unsigned a, b;
	  
	  scanf("%u%u", &a, &b);
	  graph[a - 1][b - 1] = 1;
	  graph[b - 1][a - 1] = 1;
	  m--;
	}
      result = 0;
      for (i = 0; i < n; i++)
	vertex (i);
      if (result > 1000)
	puts ("Too many maximal sets of friends.");
      else
	printf ("%u\n", result);
    }
  return EXIT_SUCCESS;
}
