#include <stdio.h>
#include <stdlib.h>

#define MAXN 400

struct reg
{
  unsigned a, b;
  _Bool sa, sb;
  int used;
};

static struct reg regs[MAXN];

struct reg *sorted_a[MAXN], *sorted_b[MAXN];

static _Bool sort_by_a;

static int
cmp_rp (const void *xa, const void *xb)
{
  struct reg *const *a_, *const *b_, *a, *b;

  a_ = xa;
  b_ = xb;
  a = *a_;
  b = *b_;
  if (a->a + a->b > b->a + b->b)
    return -1;
  if (a->a + a->b < b->a + b->b)
    return 1;
  if (sort_by_a != 0)
    {
      if (a->a > b->a)
	return -1;
      if (a->a < b->a)
	return 1;
    }
  else
    {
      if (a->b > b->b)
	return -1;
      if (a->a < b->a)
	return 1;
    }
  return 0;
}

static void
ggg (int *a, int *b, size_t num_gg, int flag, _Bool moves_a)
{
  size_t na, nb;

  na = 0;
  nb = 0;
  moves_a = 0;
  while (na != num_gg || nb != num_gg)
    {
      if (moves_a != 0)
	{
	  while (regs[na].used == flag)
	    na++;
	  regs[na].used = flag;
	  *a += regs[na].a;
	  na++;
	}
      else
	{
	  while (regs[nb].used == flag)
	    nb++;
	  regs[nb].used = flag;
	  *b += regs[nb].b;
	  nb++;
	}
      moves_a = !moves_a;
    }
}

int
main (void)
{
  int a, b;
  size_t n;

  while (scanf ("%d%d%zu", &a, &b, &n) == 3)
    {
      size_t i, best, num_gg;
      int a0, b0;
      
      for (i = 0; i < n; i++)
	{
	  char sa, sb;
	  
	  scanf ("%u%u %c %c", &regs[i].a, &regs[i].b, &sa, &sb);
	  regs[i].sa = sa == 'S';
	  regs[i].sb = sb == 'S';
	  regs[i].used = 0;
	}
      for (i = 0; i < n; i++)
	{
	  if (regs[i].sa != 0)
	    a += regs[i].a;
	}
      num_gg = 0;
      for (i = 0; i < n; i++)
	{
	  if (regs[i].sa == 0 && regs[i].sb == 0)
	    {
	      sorted_a[num_gg] = regs + i;
	      sorted_b[num_gg] = regs + i;
	      num_gg++;
	    }
	}
      sort_by_a = 1;
      qsort (sorted_a, num_gg, sizeof (*sorted_a), cmp_rp);
      sort_by_a = 0;
      qsort (sorted_b, num_gg, sizeof (*sorted_b), cmp_rp);
      /* No taking B's of sente */
      a0 = a;
      b0 = b;
      for (i = 0; i < n; i++)
	{
	  if (regs[i].sa == 0 && regs[i].sb != 0)
	    b0 += regs[i].b;
	}
      ggg (&a0, &b0, num_gg, 1, 1);
      best = n;
      for (i = 0; i < n; i++)
	{
	  if (regs[i].sa == 0 && regs[i].sb != 0)
	    {
	      if (best == n
		  || regs[best].a + regs[best].b < regs[i].a + regs[i].b)
		best = i;
	    }
	}
      if (best != n)
	a += regs[best].a;
      for (i = 0; i < n; i++)
	{
	  if (regs[i].sa == 0 && regs[i].sb != 0 && i != best)
	    b0 += regs[i].b;
	}	  
      ggg (&a, &b, num_gg, 2, 0);
      if (a - b < a0 - b0 || (a - b == a0 - b0 && a < a0))
	{
	  a = a0;
	  b = b0;
	}
      printf ("%d %d\n", a, b);
    }
  return EXIT_SUCCESS;
}
